'----------------------------------------------------------------------------
' DIRECTQB.BI
'   Include file for the DirectQB library version 1.61
'   by Angelo Mottola - Enhanced Creations 1998-99
'
' This file contains constants and function declarations used by the library
' Always include this file into your own programs!
'
' Include file created on 11-10-1999 by the DirectQB Library Manager v1.2
' Run DQBMAN again to modify your DirectQB module settings
'
'  Read DIRECTQB.DOC for detailed informations on how to use the library
'----------------------------------------------------------------------------
'$DYNAMIC
defint A-Z

#inclib "directqb"

#if __FB_LANG__="qb"
  #define i8 __byte
  #define u8 __ubyte
  #define i16 __short
  #define u16 __ushort
  #define i32 __long
  #define u32 __ulong
  #define pu8 u8 __ptr
  #define with __with
  #define screenres __screenres
  #define screenptr __screenptr
  #define screenlock __screenlock
  #define screenunlock __screenunlock
  #define cuint __cuint
  #define cast __cast
  #define cptr __cptr
  #define ptr __ptr
  #define zstring __zstring
  #define asm __asm  
  #define sizeof __sizeof
  #define allocate __allocate
  #define callocate __callocate
  #define deallocate __deallocate
  #define reallocate __reallocate
  #define dir __dir
  #define shl __shl
  #define shr __shr
  #define cvshort __cvshort
  #define setmouse __setmouse
  #define getmouse __getmouse
  #define multikey __multikey
  #define screensync __screensync
  #define flip __flip
  #define screencontrol __screencontrol
#else      
  #include "crt.bi"
  #define u8 ubyte
  #define i16 short
  #define pu8 u8 ptr
#endif

declare sub dbgprint( s as string )

' Procedures from MAIN.OBJ:
declare function DQBinit% (byval NumLayers%, byval NumSounds%, byval MemSize%)
declare function DQBver% ()
declare function DQBid$ ()
declare function DQBmapLayer% (byval Layer%)
declare sub DQBclose ()
declare sub DQBpeek (byval DataSeg%, byval DataOff%, byval Offset&, byval Length%)
declare sub DQBpoke (byval DataSeg%, byval DataOff%, byval Offset&, byval Length%)
declare sub DQBsort (byval ArraySeg%, byval ArrayOff%, byval NumRecords%, byval RecordLen%, byval IndexOff%)
declare function DQBangle% (byval x1%, byval y1%, byval x2%, byval y2%)
declare sub DQBinitVGA ()
declare sub DQBinitText ()
declare function DQBsetBaseLayer% (byval Layer%)
declare sub DQBcopyLayer (byval SourceLayer%, byval DestLayer%)
declare sub DQBclearLayer (byval Layer%)
declare sub DQBwait (byval Times%)
declare sub DQBsetFrameRate (byval FPS%)
declare function DQBframeReady% ()
declare function DQBerror$ ()

' Procedures from DRAW.OBJ:
declare sub DQBcopyTransLayer (byval SourceLayer%, byval DestLayer%)
declare sub DQBcopyHitLayer (byval SourceLayer%, byval DestLayer%, byval Col%)
declare sub DQBpset (byval Layer%, byval x%, byval y%, byval Col%)
declare function DQBpoint% (byval Layer%, byval x%, byval y%)
declare sub DQBline (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval Col%)
declare sub DQBgline (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval Col1%, byval Col2%)
declare sub DQBellipse (byval Layer%, byval x%, byval y%, byval rx%, byval ry%, byval Col%)
declare sub DQBbox (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval Col%)
declare sub DQBboxf (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval Col%)
declare sub DQBpaint (byval Layer%, byval x%, byval y%, byval Col%)
declare sub DQBscroll (byval Layer%, byval dx%, byval dy%)
declare sub DQBscrollArea (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval Direction%)
declare sub DQBsetTransPut ()
declare sub DQBsetSolidPut ()
declare sub DQBget (byval Layer, byval x1, byval y1, byval x2, byval y2, byval DummyBufSeg, byval pBuf as any ptr)
declare sub DQBput (byval Layer, byval x, byval y , byval DummyBufSeg, byval pBuf as any ptr)

' Procedures from IMAGE.OBJ:
declare function DQBloadImage (byval Layer, byval x, byval y, FileName as string, byref Pal as string, byref imgWidth as integer, byref imgHeight as integer)
declare function DQBsaveImage% (Layer%, x1%, y1%, x2%, y2%, FileName$, Pal$, Format%)
declare function DQBplayFLI% (FileName$, BufLayer%, KeyStop%, LoopFlag%)
declare function DQBopenFLI% (FileName$, Frames%, Speed%)
declare sub DQBplayFLIstep (byval Layer%)
declare sub DQBcloseFLI ()

' Procedures from SPRITE.OBJ: 
declare function DQBsize% (byval x1%, byval y1%, byval x2%, byval y2%)
declare sub DQBsetClipBox (byval x1%, byval y1%, byval x2%, byval y2%)
declare sub DQBfPut (byval Layer%, byval x%, byval y%, byval DummyBufSeg%, byval BufOff as any __ptr)
declare sub DQBsPut (byval Layer%, byval x%, byval y%, byval DummyBufSeg%, byval BufOff as any __ptr, byval NewWidth%, byval NewHeight%)
declare sub DQBrPut (byval Layer%, byval x%, byval y%, byval DummyBufSeg%, byval BufOff as any __ptr, byval Angle%, byval Zoom%)
declare sub DQBxPut (byval SourceLayer%, byval x1%, byval y1%, byval x2%, byval y2%, byval DestLayer%, byval x%, byval y%)
declare sub DQBmPut (byval Layer%, byval x%, byval y%, byval DummyBufSeg%, byval BufOff as any __ptr, byval flip%)
declare sub DQBhPut (byval Layer%, byval x%, byval y%, byval DummyBufSeg%, byval BufOff as any __ptr, byval Col%)
declare sub DQBtPut (byval Layer%, byval x%, byval y%, byval DummyBufSeg%, byval BufOff as any __ptr, byval BitMode%)
declare sub DQBpPut (byval Layer%, byval x%, byval y%, byval DummyBufSeg%, byval BufOff as any __ptr, byval Pattern%)
declare sub DQBputOver (byval DummyBackSeg%, byval BackOff as any __ptr, byval x%, byval y%, byval DummyBufSeg%, byval BufOff as any __ptr)
declare sub DQBsetCollideMethod (byval Method%)
declare function DQBcollide% (byval x1%, byval y1%, byval DummySeg1%, byval Off1 as any __ptr, byval x2%, byval y2%, byval DummySeg2%, byval Off2 as any __ptr)
declare function DQBcollideOnLayer% (byval Layer%, byval x%, byval y%, byval DummySpriteSeg%, byval SpriteOff as any __ptr)

' Procedures from BIT.OBJ:
declare function DQBsetBit% (byval Value%, byval bit%)
declare function DQBresetBit% (byval Value%, byval bit%)
declare function DQBreadBit% (byval Value%, byval bit%)
declare function DQBtoggleBit% (byval Value%, byval bit%)
declare function DQBshiftLeft% (byval Value%, byval nBits%)
declare function DQBshiftRight% (byval Value%, byval nBits%)

' Procedures from PALETTE.OBJ:
declare sub DQBsetCol (byval ColorIndex%, byval Red%, byval Green%, byval Blue%)
declare sub DQBgetCol (byval ColorIndex%, Red%, Green%, Blue%)
declare function DQBfindCol% (byval Red%, byval Green%, byval Blue%)
declare function DQBfindPalCol% (Pal$, Red%, Green%, Blue%)
declare sub DQBsetPal (Pal as string)
declare sub DQBgetPal (Pal$)
declare sub DQBfadeIn (Pal$)
declare sub DQBfadeStepIn (Pal$)
declare sub DQBfadeTo (byval Red%, byval Green%, byval Blue%)
declare sub DQBfadeStepTo (byval Red%, byval Green%, byval Blue%)
declare sub DQBpalOff ()
declare sub DQBpalRotate (byval FirstCol%, byval LastCol%, byval RotDir%)

' Procedures from FONT.OBJ:
declare sub DQBprint (Layer%, Text$, x%, y%, Col%)
declare sub DQBprints (byval Layer as integer, Text as string, byval x as integer, byval y as integer, byval Col as integer, byval Style as integer)
declare function DQBlen% (Text$)
declare sub DQBsetBIOSfont ()
declare function DQBloadFont% (FileName$)
declare sub DQBsetFont (Font$)
declare sub DQBsetTextStyle (byval Style%)
declare sub DQBsetTextBackCol (byval Col%)
declare sub DQBsetTextSpacing (byval Spacing%)
declare sub DQBsetTextBMap (byval BMap%)
declare sub DQBsetFontTexture (byval DummyTextSeg%, byval TextOff as any __ptr)

' Procedures from DISK.OBJ:
declare function DQBdir$ (Mask$, Attributes%)
declare function DQBdrive$ ()
declare function DQBpath$ ()
declare function DQBnumDrives% ()
declare sub DQBsetDrive (NewDrive$)
declare function DQBchDir (NewDir$)

' Procedures from BLENDING.OBJ:
declare sub DQBfilterBox (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval Col%, byval BMap%)
declare sub DQBbPut (byval Layer%, byval x%, byval y%, byval DummyBufSeg%, byval BufOff as any __ptr, byval BMap%)
declare sub DQBcopyBlendLayer (byval SourceLayer%, byval DestLayer%, byval BMap%)
declare function DQBcreateBMap% (byval BMap%, byval FirstCol%, byval LastCol%)
declare function DQBloadBMap% (BMap%, FileName$)
declare function DQBsaveBMap% (BMap%, FileName$)
declare sub DQBsetBMap (byval BMap%, byval ForeCol%, byval BackCol%, byval NewCol%)
declare function DQBgetBMap% (byval BMap%, byval ForeCol%, byval BackCol%)

' Procedures from KEYBOARD.OBJ:
declare sub DQBinstallKeyboard ()
declare sub DQBremoveKeyboard ()
declare function DQBkey% (byval ScanCode%)
declare function DQBreadKey% ()
declare sub DQBwaitKey (byval ScanCode%)
declare function DQBasc% (byval ScanCode%, byval ShiftFlag%)
declare function DQBinkey$ ()

' Procedures from JOYSTICK.OBJ:
declare function DQBjoyDetected% (byval JoyNum%)
declare function DQBjoyX% (byval JoyNum%)
declare function DQBjoyY% (byval JoyNum%)
declare function DQBjoyMove% (byval JoyNum%, byval Direction%)
declare function DQBjoyFire% (byval JoyNum%, byval Button%)
declare sub DQBpollJoy (byval JoyNum%)
declare sub DQBresetJoy ()
declare sub DQBsetJoySens (byval Sens%)

' Procedures from MOUSE.OBJ:
declare function DQBmouseDetected% ()
declare function DQBmouseX% ()
declare function DQBmouseY% ()
declare function DQBmouseLB% ()
declare function DQBmouseRB% ()
declare sub DQBsetMousePos (byval x%, byval y%)
declare sub DQBmouseShow ()
declare sub DQBmouseHide ()
declare sub DQBsetMouseRange (byval x1%, byval y1%, byval x2%, byval y2%)
declare sub DQBsetMouseShape (hotX%, hotY%, Shape$)
declare sub DQBsetMouseSpeed (byval HorSpeed%, byval VerSpeed%)
declare sub DQBresetMouse ()

' Procedures from SOUND.OBJ:
declare function DQBinstallSB% (byval VolActive%, byval Channels%, byval Freq%, byval BaseAddr%, byval IRQ%, byval DMA%)
declare function DQBloadSound% (Slot%, FileName$)
declare function DQBloadRawSound% (Slot%, FileName$, Offset&, Length&)
declare function DQBinUse% (byval Voice%)
declare sub DQBplaySound (byval SoundNum%, byval Voice%, byval Freq%, byval LoopFlag%)
declare sub DQBsetVoiceVol (byval Voice%, byval NewVol%)
declare sub DQBpauseSound ()
declare sub DQBresumeSound ()
declare sub DQBstopVoice (byval Voice%)
declare sub DQBremoveSB ()
declare sub DQBsetVolume (byval Volume%)

' Procedures from 3D.OBJ:
declare sub DQBtri (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval x3%, byval y3%, byval Col%)
declare sub DQBbtri (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval x3%, byval y3%, byval Col%, byval BMap%)
declare sub DQBgtri (byval Layer%, byval x1%, byval y1%, byval c1%, byval x2%, byval y2%, byval c2%, byval x3%, byval y3%, byval c3%)
declare sub DQBbgtri (byval Layer%, byval x1%, byval y1%, byval c1%, byval x2%, byval y2%, byval c2%, byval x3%, byval y3%, byval c3%, byval BMap%)
declare sub DQBttri (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval x3%, byval y3%, byval u1%, byval v1%, byval u2%, byval v2%, byval u3%, byval v3%, byval DummyTextureSeg%, byval TextureOff as any __ptr)
declare sub DQBbttri (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval x3%, byval y3%, byval u1%, byval v1%, byval u2%, byval v2%, byval u3%, byval v3%, byval DummyTextureSeg%, byval TextureOff as any __ptr, byval BMap%)
declare sub DQBfttri (byval Layer%, byval x1%, byval y1%, byval x2%, byval y2%, byval x3%, byval y3%, byval u1%, byval v1%, byval u2%, byval v2%, byval u3%, byval v3%, byval DummyTextureSeg%, byval TextureOff as any __ptr)
declare sub DQBsetTextureSize (byval Size%)

' Library constants:
const FALSE = 0, true = not FALSE, VIDEO = 0
const B0 = &H8000+1, B1 = &H8001+1, B2 = &H8002+1, B3 = &H8003+1, B4 = &H8004+1
const B5 = &H8005+1, B6 = &H8006+1, B7 = &H8007+1, B8 = &H8008+2, B9 = &H8009+2
const BSV = 0, BMP = 1, PCX = 2
const HOR = 1, VER = 2, BOX = 0, PIXEL = 1, BIT.AND = 1, BIT.OR = 2, BIT.XOR = 3
const FORWARD = 0, BACKWARD = 1
const CENTERED = &H8000, NONE = 0, SOLID = &H1, BOLD = &H2, ITALIC = &H4
const UNDERLINED = &H8, BLENDED = &H10, TEXTURED = &H20
const ATTRIB.R = &H1, ATTRIB.H = &H2, ATTRIB.S = &H4
const ATTRIB.L = &H8, ATTRIB.D = &H10, ATTRIB.A = &H20
const KEYANY = -1, KEYESC = 1, KEYENTER = 28, KEYSPACE = 57
const KEYUP = 72, KEYDOWN = 80, KEYLEFT = 75, KEYRIGHT = 77
const cUP = 0, cDOWN = 1, cLEFT = 2, cRIGHT = 3
const JOY1 = 0, JOY2 = 1, GAMEPAD = 2
const BUTA = 0, BUTB = 1, BUTC = 2, BUTD = 3
const AUTO = -1, ONCE = 0, LOOPED = 1

